DipolesRenderer
Date: 2019-10-22

org.jmol.renderspecial

## Class DipolesRenderer

- java.lang.Object
- - org.jmol.render.ShapeRenderer
  - - org.jmol.renderspecial.DipolesRenderer

-     public class DipolesRenderer
      extends ShapeRenderer

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static int` | `arrowHeadBase`
    `private static float` | `arrowHeadOffset`
    `private static int` | `arrowHeadTip`
    `private static float` | `arrowHeadWidthFactor`
    `private static int` | `center`
    `private short` | `colixA`
    `private short` | `colixB`
    `private static int` | `cross`
    `private javajs.util.P3` | `cross0`
    `private javajs.util.P3` | `cross1`
    `private static int` | `crossEnd`
    `private static float` | `crossOffset`
    `private static float` | `crossWidth`
    `private int` | `crossWidthPixels`
    `private static int` | `cylinderBase`
    `private int` | `diameter`
    `private float` | `dipoleVectorScale`
    `private int` | `headWidthPixels`
    `private boolean` | `noCross`
    `private javajs.util.V3` | `offset`
    `private float` | `offsetSide`
    `private javajs.util.P3[]` | `points`
    `private javajs.util.P3[]` | `screens3f`

    - ### Fields inherited from class org.jmol.render.ShapeRenderer

      `colix, exportType, g3d, isExport, mad, ms, myVisibilityFlag, shape, shapeID, tm, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DipolesRenderer()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `render()`
    `private boolean` | `renderDipoleVector(Dipole dipole, javajs.util.BS vis)`
    `private boolean` | `renderVector(javajs.util.V3 vector, javajs.util.P3 origin, javajs.util.P3 dcenter, float factor, boolean isGroup)`

    - ### Methods inherited from class org.jmol.render.ShapeRenderer

      `initRenderer, isVisibleForMe, renderShape, setup, setViewerG3dShapeID`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### dipoleVectorScale

          private float dipoleVectorScale

    - #### offset

          private final javajs.util.V3 offset

    - #### screens3f

          private final javajs.util.P3[] screens3f

    - #### points

          private final javajs.util.P3[] points

    - #### cross0

          private javajs.util.P3 cross0

    - #### cross1

          private javajs.util.P3 cross1

    - #### cylinderBase

          private static final int cylinderBase

      See Also:
        Constant Field Values

    - #### cross

          private static final int cross

      See Also:
        Constant Field Values

    - #### crossEnd

          private static final int crossEnd

      See Also:
        Constant Field Values

    - #### center

          private static final int center

      See Also:
        Constant Field Values

    - #### arrowHeadBase

          private static final int arrowHeadBase

      See Also:
        Constant Field Values

    - #### arrowHeadTip

          private static final int arrowHeadTip

      See Also:
        Constant Field Values

    - #### diameter

          private int diameter

    - #### headWidthPixels

          private int headWidthPixels

    - #### crossWidthPixels

          private int crossWidthPixels

    - #### offsetSide

          private float offsetSide

    - #### colixA

          private short colixA

    - #### colixB

          private short colixB

    - #### noCross

          private boolean noCross

    - #### arrowHeadOffset

          private static final float arrowHeadOffset

      See Also:
        Constant Field Values

    - #### arrowHeadWidthFactor

          private static final float arrowHeadWidthFactor

      See Also:
        Constant Field Values

    - #### crossOffset

          private static final float crossOffset

      See Also:
        Constant Field Values

    - #### crossWidth

          private static final float crossWidth

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DipolesRenderer

          public DipolesRenderer()

  - ### Method Detail

    - #### render

          protected boolean render()

      Specified by:
        `render` in class `ShapeRenderer`

    - #### renderDipoleVector

          private boolean renderDipoleVector(Dipole dipole,
                                             javajs.util.BS vis)

    - #### renderVector

          private boolean renderVector(javajs.util.V3 vector,
                                       javajs.util.P3 origin,
                                       javajs.util.P3 dcenter,
                                       float factor,
                                       boolean isGroup)